queens(N,Qs) :- range(1,N,Ns), queens(Ns,[],Qs).

queens(UnplacedQs,SafeQs,Qs) :-
    select(Q,UnplacedQs,UnplacedQs1),
    not_attack(Q,1,SafeQs),
    queens(UnplacedQs1,[Q|SafeQs],Qs).
queens([],Qs,Qs).

select(X,[X|Xs],Xs).
select(X,[Y|Ys],[Y|Zs]) :- select(X,Ys,Zs).

not_attack(Q,N,[Q1|Qs]) :- Q=\=Q1+N , Q=\=Q1-N , N1 := N+1,
    not_attack(Q,N1,Qs).
not_attack(_,_,[]).

range(M,N,[M|Ns]) :- M<N, M1 := M+1, range(M1,N,Ns).
range(N,N,[N]).
